*&* CLASSDOC.H

*&* Notes, first, followed by #DEFINEs

*&* changes in this version:

*&* * -- This is the last version that will be developed
*&* in two versions (both of which use this .H file), TEXTMERGE
*&* and low level file function.  Also, I've determined that -- 
*&* beyond the speed questions for large runs -- 
*&* TEXTMERGE can have a problem that VFP reports as "out of
*&* memory for file map", whereas we'll not have any such problem
*&* with the low levels.

*&* * -- Full pathing of VCX names is no longer shown, 
*&* except in document headers, when 
*&* there is only one directory involved.  This goes for people
*&* who have turned off DOC_PREFERENCE_OMIT_DIRSEARCH (see below)
*&* but is also in effect for runs where only one directory (the one
*&* with the baseclasses) has been selected.

*&*	* -- For all subclasses that contain more than one "level" of
*&*	information, a secondary output file is now persistent.  For
*&*	the previously-existing text classes, it contains the 
*&*	summary info that was only available from the memo field before.
*&*	For the HTML classes, since the primary file contains only
*&*	the tree of classnames, the secondary file contains the expanded 
*&*	information.
*&*	You get to pick the name and location of this second output file. 
*&*	The downside is that you have to pick another name on start up -- 
*&*	however you can pass both names into the program or use #DEFINEs to set them up 
*&*	if you don't want to bother with this.

*&*	* -- If you have been passing params to the wrapper program, please
*&*	note that they will need to be changed.  New syntax would be:
*&*	LPARAMETERS tcClassDocClass, tcBaseClassLib, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn

*&*	* -- You can set DOC_PREFERENCE_OMIT_DIRSEARCH .T. if you don't
*&*	want to be asked about other directories on startup.

*&*	* -- You can now see summary information for PEMs defined or edited
*&*	at the current class level.  This is an important change. The former shows
*&*	comments as well as PEM names, and was not available previously. You 
*&* can also choose to see PEMs hidden/protected.

*&*	* -- If a classlib containing subclasses is in USE EXCLUSIVEly somewhere
*&*	the run will still continue rather than stopping in the middle.  ClassDoc
*&*	just skips that one after letting you know.  However ClassDoc will still
*&*	stop (not create output) if the classlib with your baseclasses can't be
*&*	opened, since in that case there is nothing to do.

*&*	* -- The class tree has been extensively changed to better handle 
*&*	different types of output. The base class, now called ClassDoc is abstract,
*&*	and two new abstract levels, ClassDocWIthDocumentOutput, then ClassDocWithTextOutput, 
*&*	set up for two text targets. Another new class level, ClassDocStandardTextOutput, 
*&*	performs original "base docform" services.  However the output in this class has
*&*	changed to include PEM list and comments from
*&*	reserved3 field and #Include filename from reserved8 field. In all output
*&*	string headers have been added to make it clear that the original PEM list
*&*	was PEMs with edited values or code, whereas this list is PEMs defined at this level.

*&* * -- The wrapper program has been adjusted to handle the new output classes, of course.

*&*	* -- All strings are now localized for easier editing, so if you don't like the headers
*&*	in the output you should be able to change them easily.

*&* *-- In the VisualClassDoc (Treeview) forms, you can close the form with ESC
*&* or go to the memofields by spacebar/enter presses along with the default 
*&* doubleclick.

*&* Notes: 

	*&* Lots more can be done with the
	*&* visual components even within
	*&* the treeview-centered forms
	*&* already available in this class tree
	*&* -- I would suggest
	*&* adding an imagelist control that 
	*&* provided a picture for each of the baseclass
	*&* controls allowed by Fox.  For efficiency
	*&* I would just put this on the top level
	*&* class lines.
	
	*&* Another sample program to instantiate the
	*&* classdoc form might have a "preference" form
	*&* preceding the instantiation of the classdoc object,
	*&* so that, instead of my various rudimentary
	*&* GetDir()s and so on you'd have a chance to 
	*&* choose your output format and target filename(s), 
	*&* classdoc class to instantiate,
	*&* possible addon functions, baseclass.vcx, etc,
	*&* in a single form.
	
*&* What to do to cleanup in event of a crash 
*&* beyond the TEXTMERGE question above
*&* (Nothing here is dangerous or VCX-threatening!<s>)

	*&* If you have had a GFP while editing a VCX, it's possible 
	*&* that you have corrupted records in your VCX table that 
	*&* purport to describe normal classes but have
	*&* no objname contents.  This won't hurt you for any other 
	*&* Fox uses of the VCX, since you'll just never see those 
	*&* records. However, CLASSDOC goes from the objname of 
	*&* your libraries to hunt for descendents of each class -- so an 
	*&* empty objname will cause some endless recursion.

	*&* You will realise this when :

	*&* -- you run out of program stack levels
	*&* -- classdoc terminates abnormally as a result.

	*&* At this point you should have at least one text file 
	*&* (the main one, full docs, whose name you indicated) 
	*&* on your disk.  Depending on which CLASSDOC class you
	*&* are using, you probably have another, secondary
	*&* target file.
	
	*&* There may also be temporary working files from 
	*&* classdoc's cursors --  you will want to clean these 
	*&* up as with any other crashed VFP program!
	
	*&* You can safely delete both temporary text files, 
	*&* along with Fox's working TMP files from the cursors.  
	*&* However, before you do, *EXAMINE THE BOTTOM* 
	*&* of one of them (use MODI COMM).  You will see lots 
	*&* of empty space.  

	*&* Go back to the *last text* showing in the text file. 
	*&* This last class entry will say something like 
	*&* "class <vcxfilename>! ".  Notice the 
	*&* empty space after the delimiter. IOW, this entry 
	*&* should give you a clue as to what VCX has the 
	*&* corrupted record.  Browse this file
	*&* and figure it out! You should be able to clean up 
	*&* your VCX and re-run CLASSDOC.
	
*&* also still to be done:
	
	*&* -- allow VCXs in the chosen directories to be omitted. 
	*&* Any classes within these VCXs that are not descended from
	*&* the baseclass.vcx set of classes will be omitted anyway,
	*&* of course.  (In fact CLASSADD.PRG is a little addon to
	*&* count the number of such classes that exist with the 
	*&* VCXs examined, just to make this point.)
	
	*&* -- add other output types, such as Word documents
	*&* now that the class hierarchy is a little better designed,
	*&* and now that HTML output is possible (which could
	*&* be brought into Word for further editing)
	*&* this one is not so critical.  

*&* preferences, settable/overridable from the params for a given run:

	#DEFINE DOC_PREFERENCE_CLASS               "VisualClassDoc"
	*&* this one sets the class that is actually instantiated
	#DEFINE DOC_PREFERENCE_BASECLASS_VCX       "baseclass.vcx"
	*&* this one is the VCX from which the tree will descend
	#DEFINE DOC_PREFERENCE_PRIMARY_TARGET      ""
	*&* this one sets the primary (full output) document file
	#DEFINE DOC_PREFERENCE_SECONDARY_TARGET    ""
	*&* guess!! <g>
	#DEFINE DOC_PREFERENCE_DOCUMENT_FOLDER     ""
	*&* this one will be overridden by any paths
	*&* you specify in two target filenames
	#DEFINE DOC_PREFERENCE_OMIT_DIRSEARCH     .F.
	*&* set this one .T. if you have all your stuff in one directory
	#DEFINE DOC_PREFERENCE_ADDON               ""
	*&* this one comes from the other param -- it
	*&* runs at the end of the Init, when 
	*&* everything is done, so you can
	*&* query for statistics or whatever...

*&* additional (non-param) preferences to match the way you work:

	#DEFINE DOC_OMIT_TRYING_OCXS        .F.
	*&* make this one .T. if you know your machine
	*&* doesn't have the OCXs installed.  However,
	*&* if you don't know for certain, error checking 
	*&* should take care of it and processing should
	*&* proceed properly anyway.
	#DEFINE DOC_OMIT_TRYING_COMMON_DIALOG  .F.
	*&* make this one .T. if you just want to omit
	*&* the common dialog but still want other ActiveX
	*&* activity to proceed in your subclasses

	#DEFINE DOC_BETWEEN_CLASSES         REPL("-",60)
	#DEFINE DOC_BETWEEN_TOP_CLASSES     REPL("_",60)
	*&* delimiters in text output
	#DEFINE DOC_COL_INDENT              25
	*&* Multipler for pixels to indent each class level for HTML output

	#DEFINE DOC_DEBUG                   .F.
	*&* do you want to SUSPEND at a ClassDoc error?

	* the following provide a unique key for my target file -- 
	* change the first one to change the "look" of output,
	* but if you change the other 3 they must remain in synch
	* with each other:
	#DEFINE DOC_CLASS_DELIMITER         "!"
	#DEFINE DOC_CLASS_IDENTIFIER        ALLTR(ObjLoc)+DOC_CLASS_DELIMITER+ALLT(ObjName)
	#DEFINE DOC_PARENTCLASS_IDENTIFIER  ALLTR(ClassLoc)+DOC_CLASS_DELIMITER+ALLTR(Class)
	#DEFINE DOC_BASECLASS_IDENTIFIER    LOWER(THIS.cBaseClassLibFileName+DOC_CLASS_DELIMITER+ALLTR(ObjName))

	*&* change the following to mirror any other classes you add to the CLASSDOC tree:
	#DEFINE DOC_AVAILABLE_CLASSES      "CLASSDOCSTANDARDTEXTOUTPUT", ;
	                                   "CLASSDOCWITHSUMMARY",;
	                                   "CLASSDOCMEMBERSEDITED","CLASSDOCMEMBERSDEFINED","CLASSDOCMEMBERSPROTECTED",;
	                                   "VISUALCLASSDOC", ;
	                                   "VISUALCLASSDOCMEMBERSEDITED","VISUALCLASSDOCMEMBERSDEFINED",;
	                                   "CLASSDOCHTMLOUTPUT", ;
	                                   "CLASSDOCHTMLEXPANDPEMSEDITED","CLASSDOCHTMLEXPANDPEMSDEFINED","CLASSDOCHTMLEXPANDPEMSPROTECTED"
	                                   
	
	
*&* localization/strings:

    #DEFINE DOCSTRING_PROCESSING_BASECLASSES          "Processing baseclass "+ALLTR(ObjName)+" and its children, please be patient... "
    #DEFINE DOCSTRING_USING_DEFAULT_BASECLASSES       "Using default class "+cClassName+"..." 
    #DEFINE DOCSTRING_PREPARING_WORKFILES             "Preparing workfiles, please wait... "
    #DEFINE DOCSTRING_ADDON_DOES_NOT_EXIST            "AddOn "+THIS.cAddOn+" does not exist."
    #DEFINE DOCSTRING_NO_TREEVIEW                     "Couldn't instantiate Treeview Control properly for some reason."
    #DEFINE DOCSTRING_DOC_CREATED                     "Your class documentation has been " + ;
                                                      "created as "+THIS.cPrimaryDocTarget+"."
    #DEFINE DOCSTRING_DOCUMENTS_CREATED               "Your class documentation has been " + ;
                                                      "created as "+THIS.cPrimaryDocTarget+" and "+ ;
                                                      THIS.cSecondaryDocTarget+"."
    #DEFINE DOCSTRING_BASECLASSES_NOT_AVAILABLE       "Base class library can't be read."                                                      
    #DEFINE DOCSTRING_CLASSLIB_NOT_AVAILABLE          tcFolder+aLibs[iIndex,1]+ " can't be read -- will be skipped."
    
    #DEFINE DOCSTRING_NO_BASECLASSES                  "There are no viable baseclass records in the VCX you chose."
    #DEFINE DOCSTRING_OUTPUT_FILE_NOT_SPECIFIED       "Output file not specified."
    #DEFINE DOCSTRING_BASECLASSES_NOT_SPECIFIED       "Base class library not specified."
    #DEFINE DOCSTRING_BASECLASSES_NOT_FOUND           "Base class library does not exist or can't be found."
    #DEFINE DOCSTRING_UTILITY_NAME                    "ClassDoc"
    #DEFINE DOCSTRING_PROBLEM                         "Problem"
    #DEFINE DOCSTRING_PICK_PRIMARY_TARGET             "Designate your output file for primary output." 
    #DEFINE DOCSTRING_PICK_SECONDARY_TARGET           "Designate your output file for secondary output."
    #DEFINE DOCSTRING_FILENAMES_MUST_DIFFER           "Full and summary output must go to different files.  " + ;
                                                      "Secondary output filename will be: "+THIS.cSecondaryDocTarget+"."
    #DEFINE DOCSTRING_OTHER_VCX_DIRS                  "Other VCXs to process?"
    #DEFINE DOCSTRING_DIALOG_CAPTION                  "Document Your Class Hierarchy"
    #DEFINE DOCSTRING_SCANNING_FOR_CHILDREN           "Scanning for children of: "    
    #DEFINE DOCSTRING_DEFAULT_GETFILE_PROMPT          "Designate your output document"
    #DEFINE DOCSTRING_GETFILE_DEFAULT                 "Default:  "
    #DEFINE DOCSTRING_GET_BASECLASSES                 "Please Find Your Base Class Library"
    #DEFINE DOCSTRING_CALLING_BROWSER                 "Calling browser to display your results, please wait..."
    
    *&* The following group of strings may appear in textmerged output. 
    *&* They are given as literals for speed and should not have delimiters.
    
    *&* You can use them in expressions in additional
    *&* (non textmerge) code, as long as you delimit them
    *&* using square brackets in your code (don't try other
    *&* delimiters, only square brackets).
    *&* For example:
    *&* THIS.MyFeedBackMethod([DOCSTRING_NO_PEMS_DEFINED])
    
    
    #DEFINE DOCSTRING_INCLUDE_FILE                    Include file
    #DEFINE DOCSTRING_NO_INCLUDE_FILE                 No Include file for this class.
    #DEFINE DOCSTRING_CHILD_OF                        child of
    #DEFINE DOCSTRING_NO_PROPERTIES_EDITED            No properties assigned values at this class level.
    #DEFINE DOCSTRING_PROPERTIES_EDITED               Properties assigned values at this class level:
    #DEFINE DOCSTRING_NO_METHODS_EDITED               No methods assigned code at this class level.
    #DEFINE DOCSTRING_METHODS_EDITED                  Methods with code at this class level:
    #DEFINE DOCSTRING_NO_PEMS_EDITED                  No Methods or Properties edited with code or values at this class level.    
    #DEFINE DOCSTRING_PEMS_EDITED                     Methods and Properties with code or values at this class level:    
    #DEFINE DOCSTRING_NO_PEMS_DEFINED                 No properties and methods defined at this class level.    
    #DEFINE DOCSTRING_PEMS_DEFINED                    Properties and Methods defined at this class level (methods have *, arrays have ^):
    #DEFINE DOCSTRING_PEMS_PROTECTED                  Properties and Methods protected at this class level (hidden PEMs end in ^):
    #DEFINE DOCSTRING_NO_PEMS_PROTECTED               No properties and methods protected or hidden at this class level.    
    #DEFINE DOCSTRING_DRILLDOWN                       PEMs
    #DEFINE DOCSTRING_NO_DRILLDOWN                    No PEMs
    #DEFINE DOCSTRING_BACK_TO_CLASSLIST               Back to classlist
    
    *&* This one's an exception -- it's an expression, because it's complex.
    *&* Since it's only used once per output file, that's okay,it isn't
    *&* getting evaluated numerous times:
    #DEFINE DOCSTRING_ONE_DIRECTORY_HEADER_EXPR      "Classes descended from baseclasses in "+ ;
                                                      UPPER(SUBSTR(THIS.cBaseClassLibFileName,;
                                                            RAT("\",THIS.cBaseClassLibFileName)+1))+ ;
                                                     CHR(13)+CHR(10)+"located in "+ ;
                                                      UPPER(SUBSTR(THIS.cBaseClassLibFileName,;
                                                            1,RAT("\",THIS.cBaseClassLibFileName)))+;
                                                      " directory"
    
    
    

*&* some required constants follow here, none of which you should need to change:

	*&* general messagebox stuff:
		#DEFINE DOC_STOP_MESSAGEBOX              16,DOCSTRING_UTILITY_NAME+" "+DOCSTRING_PROBLEM
		#DEFINE DOC_INFO_MESSAGEBOX              64,DOCSTRING_UTILITY_NAME
		#DEFINE DOC_WARNING_MESSAGEBOX           48,DOCSTRING_UTILITY_NAME+" "+DOCSTRING_PROBLEM

	*&* error handling lookup:
		#DEFINE DOC_OLE_ERRORS                   "/1420/1421/1422/1423/1424/1426/1427/1428/1429/1431/1434/1436/1508/"

	*&* text parsing stuff:
		#DEFINE C_TAB                       CHR(9)
		* tab character
		#DEFINE C_CR                        CHR(13)
		* carriage return
		#DEFINE C_CRLF                      CHR(13)+CHR(10)
		* carriage return linefeed, used in VCX memofields??
		#DEFINE C_DOUBLE_CR                 CHR(13)+CHR(13)
		* double carriage return
		#DEFINE C_CONTINUATION_SYMBOL       CHR(59)
		* semi-colon
		#DEFINE N_MEMOWIDTH                 1024
		* SET MEMOWIDTH to current outside limit

	*&* common dialog control constants:
		#DEFINE cdlOFNPathMustExist                     0x800	
		* User can enter only valid path names.
		#DEFINE cdlOFNFileMustExist                     0x1000	
		* User can enter only names of existing files.
		#DEFINE cdlOFNNoChangeDir                       0x8
		* Sets the current directory to what it was when the dialog box was invoked.
		#DEFINE cdlOFNHideReadOnly                      0x4
		* hide readonly checkbox

