*&* CLASSDOCTXT.PRG
*&* to document class hierarchies
*&* This is the last TEXTMERGE
*&* version I will produce.
*&* >L< Revisions June 98

*&* See CLASSDOC.H for notes.

#INCLUDE CLASSDOC.H

*&***************************************** 
* this section is the silly sample program
* to instantiate the ClassDoc class of your choice
*&***************************************** 

LPARAMETERS tcClassDocClass, tcBaseClassLib, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn
LOCAL cAsserts, oForm, cClass
cAsserts = SET("ASSERTS")
SET ASSERTS ON
ASSERT TYPE("tcClassDocClass") # "C" OR INLIST(UPPER(tcClassDocClass),DOC_AVAILABLE_CLASSES ) ;
       MESSAGE "Pass only an available class from #DEFINEd DOC_AVAILABLE_CLASSES."
IF TYPE("tcClassDocClass") = "C"
   cClass = tcClassDocClass
ELSE
   cClass = GetClass()
ENDIF
oForm = CREATEOBJECT(cClass, tcBaseClassLib, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn )
IF TYPE("oForm") = "O" AND oForm.lVisibleComponents 
   oForm.Show(1)
ENDIF
SET ASSERTS &cAsserts
RETURN

PROCEDURE GetClass
LOCAL cClassName
  *&* comment out the block below if you don't want to bother with this
  *&* and just want to use the #DEFINEd DOC_PREFERENCE_CLASS each time:
   DEFINE POPUP classdoc COLOR SCHEME 4 FONT _SCREEN.FontName, 10 STYLE "B" ;
          TITLE "Choose a class:"
   ON SELECTION POPUP classdoc DEAC POPUP
   DEFINE BAR 1  OF classdoc PROMPT "ClassDocStandardTextOutput: lowest-level class, no visual components, full textfile only"
   DEFINE BAR 2  OF classdoc PROMPT "ClassDocWithSummary: no visual components, secondary text file shows class names"   
   DEFINE BAR 3  OF classdoc PROMPT "ClassDocMembersEdited: no visual components, secondary text file shows classes + PEMs edited"
   DEFINE BAR 4  OF classdoc PROMPT "ClassDocMembersDefined: no visual components, secondary text file shows classes + PEMs defined"
   DEFINE BAR 5  OF classdoc PROMPT "ClassDocMembersProtected:  no visual components, secondary text file shows classes + PEMs protected"
   DEFINE BAR 6  OF classdoc PROMPT "VisualClassDoc: treeview of class names, dblclick to memo field with full documentation"   
   DEFINE BAR 7  OF classdoc PROMPT "VisualClassDocMembersEdited: treeview, dblclick to memofield with PEMs edited"
   DEFINE BAR 8  OF classdoc PROMPT "VisualClassDocMembersDefined: treeview, dblclick to memofield with PEMs defined"
   DEFINE BAR 9  OF classdoc PROMPT "ClassDocHTMLOutput: test of HTML processing, classes only, no drilldown"
   DEFINE BAR 10 OF classdoc PROMPT "ClassDocHTMLExpandPEMsEdited: classes drilldown to PEMs edited"   
   DEFINE BAR 11 OF classdoc PROMPT "ClassDocHTMLExpandPEMsDefined: classes drilldown to PEMs defined"      
   DEFINE BAR 12 OF classdoc PROMPT "ClassDocHTMLExpandPEMsProtected: classes drilldown to PEMs protected"            
   ACTI POPUP classdoc  AT SROWS()/3,5
   cClassName = LEFT(PROMPT(),AT(":",PROMPT())-1)
   RELEASE POPUP classdoc
  *&* end of block to comment out
  
   IF EMPTY(cClassName)
      cClassName = DOC_PREFERENCE_CLASS
      WAIT WINDOW DOCSTRING_USING_DEFAULT_BASECLASSES NOWAIT
   ELSE
      WAIT WINDOW cClassName NOWAIT      
   ENDIF

RETURN cClassName  

*&***************************************** 
* CLASSDOC class definitions follow.
*&***************************************** 


* notes for HMTL classes, in progress:
* the HTML classes will reverse the strategy
* used in the straight text classes,
* in that the summary format will always
* be prepared, with the fuller information
* available from the secondary target,
* which will be linked to by the main document.
* Indentation will be by way of tables.


DEFINE CLASS ClassDocHTMLExpandPEMsEdited AS ClassDocHTMLOutput

   lSecondaryOutput = .T.
   cSummaryStyle = "EDITED"
   
   PROC CheckClassForSecondaryOutput
      LOCAL lReturn
      lReturn = THIS.lSecondaryOutput AND (NOT EMPTY(ALLTRIM(Properties)+ALLTR(Methods)))
   RETURN lReturn
   
   PROC CreateSecondaryOutput(tcThisClass, tiThisCount,tlHasSecondaryOutput)
      IF DODEFAULT(tcThisClass, tiThisCount)
         LOCAL lcRef
         lcRef = CHRTRAN(tcThisClass,SPACE(1)+"\.:"+DOC_CLASS_DELIMITER,"_")         
         \<A NAME="<<lcRef>>"> 
         \<A HREF="file:///<<THIS.cPrimaryDocTarget>>#<<lcRef>>">DOCSTRING_BACK_TO_CLASSLIST: <<tcThisClass>></A>
         \<BR>
         LOCAL cContents, iIndex, cThisLine               
         \<BLOCKQUOTE>
         \<I>DOCSTRING_PEMS_EDITED</I>
         \<BR>                        
         \<<STRTRAN(Properties,C_CRLF,"<BR>")>>
         cContents = ALLTR(Methods)
         _MLINE = 0
         FOR iIndex = 1 TO MEMLINES(cContents)
            cThisLine = MLINE(cContents,1,_MLINE)
            IF LEFT(ALLTR(UPPER(cThisLine)),4) == "PROC"
               \<<cThisLine>>
               \<BR>
            ENDIF
         ENDFOR
         \</BLOCKQUOTE>            
         \<BR>
      ENDIF
   RETURN NOT THIS.lError

ENDDEFINE

DEFINE CLASS ClassDocHTMLExpandPEMsProtected AS ClassDocHTMLOutput

   lSecondaryOutput = .T.
   cSummaryStyle = "PROTECTED"
   
   PROC CheckClassForSecondaryOutput
      LOCAL lReturn
      lReturn = THIS.lSecondaryOutput AND (NOT EMPTY(ALLTRIM(Protected)))
   RETURN lReturn
   
   PROC CreateSecondaryOutput(tcThisClass, tiThisCount)
      IF  DODEFAULT(tcThisClass, tiThisCount)
         LOCAL lcRef
         lcRef = CHRTRAN(tcThisClass,SPACE(1)+"\.:"+DOC_CLASS_DELIMITER,"_")         
         \<A NAME="<<lcRef>>"> 
         \<A HREF="file:///<<THIS.cPrimaryDocTarget>>#<<lcRef>>">DOCSTRING_BACK_TO_CLASSLIST: <<tcThisClass>></A>
         \<BR>
         \<BLOCKQUOTE>            
         \<I>DOCSTRING_PEMS_PROTECTED</I>            
         \<BR>
         \<<STRTRAN(ALLTR(Protected),C_CRLF,"<BR>")>>
         \</BLOCKQUOTE>
         \<BR>
      ENDIF
   RETURN NOT THIS.lError
   
ENDDEFINE


DEFINE CLASS ClassDocHTMLExpandPEMsDefined AS ClassDocHTMLOutput

   lSecondaryOutput = .T.
   cSummaryStyle = "DEFINED"
   
   PROC CheckClassForSecondaryOutput
      LOCAL lReturn
      lReturn = THIS.lSecondaryOutput AND (NOT EMPTY(ALLTRIM(Reserved3)))
   RETURN lReturn
   
   PROC CreateSecondaryOutput(tcThisClass, tiThisCount)
      IF  DODEFAULT(tcThisClass, tiThisCount)
         LOCAL lcRef
         lcRef = CHRTRAN(tcThisClass,SPACE(1)+"\.:"+DOC_CLASS_DELIMITER,"_")         
         \<A NAME="<<lcRef>>"> 
         \<A HREF="file:///<<THIS.cPrimaryDocTarget>>#<<lcRef>>">DOCSTRING_BACK_TO_CLASSLIST: <<tcThisClass>></A>
         \<BR>
         \<BLOCKQUOTE>            
         \<I>DOCSTRING_PEMS_DEFINED</I>            
         \<BR>
         \<<STRTRAN(ALLTR(Reserved3),C_CRLF,"<BR>")>>
         \</BLOCKQUOTE>
         \<BR>
      ENDIF
   RETURN NOT THIS.lError
   
ENDDEFINE

DEFINE CLASS ClassDocHTMLOutput AS ClassDocWithTextOutput

   cExt = "HTM"
   cExtPickString = "HTML files (*.htm)|*.htm|All files|*.*"
   lVisibleComponents = .T.
   lSecondaryOutput = .F.
   
   PROC CreateClassOutput(tcThisClass,tiThisCount)
      LOCAL lHasSecondaryOutput, lReturn
      lReturn = DODEFAULT()
      IF lReturn
         lHasSecondaryOutput = THIS.CheckClassForSecondaryOutput()
         THIS.CreatePrimaryOutput(tcThisClass,tiThisCount,lHasSecondaryOutput)
         IF lHasSecondaryOutput
            THIS.CreateSecondaryOutput(tcThisClass,tiThisCount)
         ENDIF
      ENDIF
   RETURN lReturn AND (NOT THIS.lError)
   
   PROC CheckClassForSecondaryOutput()
   RETURN THIS.lSecondaryOutput
   
   PROC CreatePrimaryOutput(tcThisClass, tiThisCount,tlHasSecondaryOutput)
      IF DODEFAULT(tcThisClass, tiThisCount)
         LOCAL lcRef
         lcRef = CHRTRAN(tcThisClass,SPACE(1)+"\.:"+DOC_CLASS_DELIMITER,"_")
         \<BR>
         \<TABLE BORDER=0>
         \<TR>
         \<TD WIDTH=<<DOC_COL_INDENT*tiThisCount>> > </TD>
         \<TD><A NAME="<<lcRef>>"><<tcThisClass>></TD>         
         IF THIS.lSecondaryOutput
            \<TD ALIGN="RIGHT"> 
            IF tlHasSecondaryOutput
               \<A HREF="file:///<<THIS.cSecondaryDocTarget>>#<<lcRef>>">DOCSTRING_DRILLDOWN</A>
            ELSE
               \&nbsp;&nbsp;<I>(DOCSTRING_NO_DRILLDOWN)</I>
            ENDIF
            \</TD>
         ENDIF
         \</TR>
         \</TABLE>
      ENDIF
   RETURN NOT THIS.lError
   
   PROC CreateHeader()
      \<HTML>
      \<HEADER>
      \<TITLE>
      \<<THIS.Caption>>
      \</TITLE>
      \</HEADER>
      \<BODY>
      IF THIS.lOmitDirSearch
         \<H2>
         \<<STRTRAN(DOCSTRING_ONE_DIRECTORY_HEADER_EXPR,CHR(13)+CHR(10),CHR(13)+CHR(10)+[<BR>]+CHR(13)+CHR(10))>>
         \</H2>
         \<P>
      ENDIF
      IF THIS.lSecondaryOutput
         \<P>
         \<A HREF="file:///<<THIS.cSecondaryDocTarget>>">DOCSTRING_DRILLDOWN</A>
         \<P>
         SET TEXTMERGE TO (THIS.cSecondaryDocTarget) ADDITIVE
         \<HTML>
         \<HEADER>
         \<TITLE>
         \<<THIS.Caption>> DOCSTRING_DRILLDOWN
         \</TITLE>
         \</HEADER>
         \<BODY>
         \
         \<<STRTRAN(DOCSTRING_ONE_DIRECTORY_HEADER_EXPR,CHR(13)+CHR(10),CHR(13)+CHR(10)+[<BR>]+CHR(13)+CHR(10))>>
         \
         \<P>
         \<A HREF="file:///<<THIS.cPrimaryDocTarget>>">DOCSTRING_BACK_TO_CLASSLIST</A>
         \<P>
         SET TEXTMERGE TO (THIS.cPrimaryDocTarget) ADDITIVE
      ENDIF
         
   RETURN NOT THIS.lError
   
   PROC CreateFooter()
      IF THIS.lSecondaryOutput
         SET TEXTMERGE TO (THIS.cPrimaryDocTarget) ADDITIVE
      ENDIF
      \</BODY>
      \</HTML>
      IF THIS.lSecondaryOutput
         SET TEXTMERGE TO (THIS.cSecondaryDocTarget) ADDITIVE
         \</BODY>
         \</HTML>
      ENDIF
      
   RETURN NOT THIS.lError
   
   PROC Show(tnStyle)
      * for now, although
      * we could use the web browser ocx...
      NODEFAULT
      IF NOT THIS.lError
         WAIT WINDOW DOCSTRING_CALLING_BROWSER NOWAIT
         DECLARE long ShellExecuteA IN SHELL32 ;
           long, string, string, string, string, long
         ShellExecuteA( 0, "open",  ;
                       THIS.cPrimaryDocTarget, "","", 1 )
      ENDIF
   ENDPROC
   

ENDDEFINE   



DEFINE CLASS VisualClassDocMembersEdited AS VisualClassDoc
   lSecondaryOutput = .T.
   cSummaryStyle = "EDITED"
ENDDEFINE

DEFINE CLASS VisualClassDocMembersDefined AS VisualClassDoc 
   lSecondaryOutput = .T.
   cSummaryStyle = "DEFINED"
ENDDEFINE


DEFINE CLASS VisualClassDoc AS ClassDocWithSummary

   AutoCenter = .T.
   
   cNodes = ""
   cEditAlias = "Editor"
   
   lVisibleComponents = .T.   
   lSecondaryOutput = .F.

   ADD OBJECT trvClassDoc AS trvDoc
   
   PROC Init(tcBaseClassLibFileName, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn )   
   
     LOCAL lReturn
     
     lReturn = DODEFAULT(tcBaseClassLibFileName, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn )     
     IF lReturn
        lReturn = THIS.CreateEditingCursor()
     ENDIF
     IF lReturn
        lReturn = THIS.FillEditingCursor()
     ENDIF
     IF lReturn
        THIS.SetAll("Sorted",.T.)
        THIS.Resize()
     ENDIF

   RETURN lReturn AND (NOT THIS.lError)
   

   PROC Resize()
      DODEFAULT()
      THIS.trvClassDoc.Resize()
   ENDPROC
   
   PROC trvClassDoc.Resize()
      DODEFAULT()
      THIS.Height = THISFORM.Height
      THIS.Width = THISFORM.Width
   ENDPROC
  
   PROC trvClassDoc.KeyPress(nKeyCode, nShiftAltCtrl)
      DO CASE
      CASE INLIST(nKeyCode,13,32)
          THIS.DblClick()
      CASE nKeyCode = 27
          KEYBOARD "{CTRL-F4}"
      ENDCASE
   ENDPROC
   
   PROC trvClassDoc.DblClick()
      LOCAL iPos, cKey
      IF TYPE("THIS.SelectedItem.Key") = "C"
          cKey = THIS.SelectedItem.Key 
          IF THISFORM.lOmitDirSearch
             cKey = SUBSTR(cKey,RAT("\",cKey)+1)
          ENDIF
          iPos = ATC(cKey,EVAL(THISFORM.cEditAlias+".Output"))          
          MODI MEMO (THISFORM.cEditAlias+".Output") RANGE iPos, iPos+LEN(cKey)
      ELSE
          MODI MEMO (THISFORM.cEditAlias+".Output") 
      ENDIF
      DODEFAULT()
   ENDPROC
   
   PROC CreateClassOutput(tcThisClass,tiThisCount)
      LOCAL oNode, lReturn, cClass
      lReturn =  DODEFAULT(tcThisClass, tiThisCount)
      IF lReturn
         IF THIS.lOmitDirSearch
            cClass = THIS.cLibPath+tcThisClass
         ELSE
            cClass = tcThisClass
         ENDIF
      ENDIF
      IF lReturn AND (NOT (THIS.lOLEError OR "/"+cClass+"/" $ THIS.cNodes))
         IF tiThisCount = 1     
            * Add(relative, relationship, key, text, image, selectedimage)
            SELECT (THIS.cSourceAlias)
            oNode = THIS.trvClassDoc.Nodes.Add( ;
                            , ,cClass,ALLTR(ObjName))
         ELSE
            SELECT (THIS.cTargetAlias)
            oNode = THIS.trvClassDoc.Nodes.Add( ;
                         DOC_PARENTCLASS_IDENTIFIER,4, ;
                         cClass,tcThisClass)
         ENDIF     
         oNode.Expanded = .F.
         THIS.cNodes = THIS.cNodes+"/"+cClass+"/"   
      ENDIF       
         
   RETURN NOT THIS.lError      
   
   PROC CreateEditingCursor
      CREATE CURSOR (THIS.cEditAlias) ;
                    (Output M)
      APPEND BLANK
   ENDPROC

   PROC FillEditingCursor
      SELECT (THIS.cEditAlias)
      IF THIS.lSecondaryOutput
         APPEND MEMO Output FROM (THIS.cSecondaryDocTarget)
      ELSE
         APPEND MEMO Output FROM (THIS.cPrimaryDocTarget)      
      ENDIF
   RETURN NOT THIS.lError      
   
   PROC SHOW(nStyle)
      IF TYPE("THIS.trvClassDoc.Nodes(1).Key") # "C"
         * ole error for some reason...
         MESSAGEBOX(DOCSTRING_NO_TREEVIEW, ;
                    DOC_STOP_MESSAGEBOX )
         THIS.lVisibleComponents = .F.
         NODEFAULT
      ENDIF
   ENDPROC
  
ENDDEFINE

DEFINE CLASS ClassDocMembersDefined AS ClassDocWithSummary
   cSummaryStyle = "DEFINED"
 
ENDDEFINE

DEFINE CLASS ClassDocMembersEdited AS ClassDocWithSummary
   cSummaryStyle = "EDITED"
ENDDEFINE

DEFINE CLASS ClassDocMembersProtected AS ClassDocWithSummary
   cSummaryStyle = "PROTECTED"
ENDDEFINE


DEFINE CLASS ClassDocWithSummary AS ClassDocStandardTextOutput

   lSecondaryOutput = .T.
   cSummaryStyle = ""
      
   PROC CreateSecondaryOutput(tcThisClass,tiThisCount)
      IF DODEFAULT(tcThisClass, tiThisCount)
         IF tiThisCount = 1
            \<<DOC_BETWEEN_TOP_CLASSES>>
         ELSE
            \<<DOC_BETWEEN_CLASSES>>
         ENDIF
         \<<tcThisClass>>
      ENDIF
      IF NOT EMPTY(THIS.cSummaryStyle)
         \\, DOCSTRING_CHILD_OF <<ALLTR(Class)>>
         \
         THIS.CreateSummaryOutput()
         \
      ENDIF

   RETURN NOT THIS.lError
   
   PROC CreateSummaryOutput
      DO CASE
      CASE THIS.cSummaryStyle == "DEFINED"
         IF EMPTY(ALLTRIM(Reserved3))
            \DOCSTRING_NO_PEMS_DEFINED
         ELSE      
            \DOCSTRING_PEMS_DEFINED
            \
            \<<STRTRAN(ALLTR(Reserved3),C_CRLF,C_CRLF+_PRETEXT)>>
         ENDIF
      CASE THIS.cSummaryStyle == "PROTECTED"
         IF EMPTY(ALLTRIM(Protected))
            \DOCSTRING_NO_PEMS_PROTECTED
         ELSE      
            \DOCSTRING_PEMS_PROTECTED
            \
            \<<STRTRAN(ALLTR(Protected),C_CRLF,C_CRLF+_PRETEXT)>>
         ENDIF
      CASE THIS.cSummaryStyle == "EDITED"
         LOCAL cContents, iIndex, cThisLine               
         IF EMPTY(ALLTRIM(Properties)+ALLTRIM(Methods))
            \DOCSTRING_NO_PEMS_EDITED
         ELSE
            \DOCSTRING_PEMS_EDITED
            \
            \<<STRTRAN(Properties,C_CRLF,C_CRLF+_PRETEXT)>>
            cContents = ALLTR(Methods)
            _MLINE = 0
            FOR iIndex = 1 TO MEMLINES(cContents)
               cThisLine = MLINE(cContents,1,_MLINE)
               IF LEFT(ALLTR(UPPER(cThisLine)),4) == "PROC"
                  \<<cThisLine>>
               ENDIF
            ENDFOR
         ENDIF
      ENDCASE
   RETURN NOT THIS.lError

ENDDEFINE


DEFINE CLASS ClassDocStandardTextOutput AS ClassDocWithTextOutput

   PROC CreateClassOutput(tcThisClass,tiThisCount)
      LOCAL lReturn
      lReturn = DODEFAULT(tcThisClass, tiThisCount)   
      IF lReturn
         THIS.CreatePrimaryOutput(tcThisClass,tiThisCount)
         IF THIS.lSecondaryOutput
            THIS.CreateSecondaryOutput(tcThisClass,tiThisCount)
         ENDIF
      ENDIF
   RETURN lReturn AND (NOT THIS.lError)
   
  
   PROC CreateHeader()
      _PRETEXT = ""
      IF THIS.lOmitDirSearch
         SET TEXTMERGE TO (THIS.cPrimaryDocTarget) ADDITIVE
         \
         \<<DOCSTRING_ONE_DIRECTORY_HEADER_EXPR>>
         \
         IF THIS.lSecondaryOutput
            SET TEXTMERGE TO (THIS.cSecondaryDocTarget) ADDITIVE         
            \
            \<<DOCSTRING_ONE_DIRECTORY_HEADER_EXPR>>
            \
         ENDIF
      ENDIF
   RETURN (NOT THIS.lError)

   
   RETURN (NOT THIS.lError)
   
   PROC CreatePrimaryOutput(tcThisClass, tiThisCount)
      IF DODEFAULT(tcThisClass,tiThisCount)
         * indent one less tabs than class levels...
         _PRETEXT = REPL(C_TAB,tiThisCount - 1)
         IF tiThisCount = 1
            \<<DOC_BETWEEN_TOP_CLASSES>>
         ELSE
            \<<DOC_BETWEEN_CLASSES>>
         ENDIF
         \Class:<<SPACE(2)>>
         \\<<tcThisClass>>
         \\, child of <<ALLTR(Class)>>
         \
         IF EMPTY(ALLTRIM(Properties))
            \DOCSTRING_NO_PROPERTIES_EDITED
         ELSE
            \DOCSTRING_PROPERTIES_EDITED
            \
            \<<STRTRAN(Properties,C_CRLF,C_CRLF+_PRETEXT)>>
         ENDIF
         \
         IF EMPTY(ALLTR(Methods))
            \DOCSTRING_NO_METHODS_EDITED
         ELSE
            \DOCSTRING_METHODS_EDITED
            \
            \<<STRTRAN(Methods,C_CRLF, C_CRLF+_PRETEXT)>>
         ENDIF
         \
         IF EMPTY(ALLTRIM(Reserved3))
           \DOCSTRING_NO_PEMS_DEFINED
         ELSE
            \DOCSTRING_PEMS_DEFINED
            \
            \<<STRTRAN(Reserved3,C_CRLF, C_CRLF+_PRETEXT)>>      
         ENDIF
         \
         IF EMPTY(ALLTR(Reserved8))
            \DOCSTRING_NO_INCLUDE_FILE
         ELSE
            \DOCSTRING_INCLUDE_FILE:  <<UPPER(ALLTR(Reserved8))>>
         ENDIF
         \
         IF EMPTY(ALLTR(Protected))
            \DOCSTRING_NO_PEMS_PROTECTED
         ELSE
            \DOCSTRING_PEMS_PROTECTED
            \
            \<<STRTRAN(Protected,C_CRLF, C_CRLF+_PRETEXT)>>      
         ENDIF
         \
      ENDIF
   RETURN NOT THIS.lError
   
   
ENDDEFINE

DEFINE CLASS ClassDocWithTextOutput AS ClassDocWithDocumentOutput

   PROC CreatePrimaryOutput(tcThisClass,tiThisCount)
      IF THIS.lSecondaryOutput
         SET TEXTMERGE TO (THIS.cPrimaryDocTarget) ADDITIVE
      ENDIF
   RETURN NOT THIS.lError
   
   PROC CreateSecondaryOutput(tcThisClass,tiThisCount)
      IF THIS.lSecondaryOutput   
         SET TEXTMERGE TO (THIS.cSecondaryDocTarget) ADDITIVE
      ENDIF
   RETURN NOT THIS.lError
   
   PROC ProcessTargetFile
      LOCAL lReturn
      SET TEXTMERGE TO (THIS.cPrimaryDocTarget)
      SET TEXTMERGE ON NOSHOW
      SET TEXTMERGE DELIMITERS
      lReturn = DODEFAULT()
      SET TEXTMERGE OFF
      SET TEXTMERGE TO
   RETURN lReturn AND (NOT THIS.lError)

ENDDEFINE


DEFINE CLASS ClassDocWithDocumentOutput AS ClassDoc

   lSecondaryOutput = .F.
   cPrimaryDocTarget =  DOC_PREFERENCE_PRIMARY_TARGET 
   cSecondaryDocTarget = DOC_PREFERENCE_SECONDARY_TARGET
   cDocumentFolder = DOC_PREFERENCE_DOCUMENT_FOLDER
   cExt = "TXT"
   cExtPickString = "Text files (*.txt)|*.txt|All files|*.*"
   
   PROC Init(tcBaseClassLibFileName, tcPrimaryDocTarget, tcSecondaryDocTarget,tcAddOn )
      IF TYPE("tcPrimaryDocTarget") = "C"
         THIS.cPrimaryDocTarget = tcPrimaryDocTarget
      ENDIF
      IF TYPE("tcSecondaryDocTarget") = "C"
         THIS.cSecondaryDocTarget = tcSecondaryDocTarget
      ENDIF
      LOCAL lReturn
      lReturn = THIS.SetDocTargets()
      IF lReturn
         lReturn = DODEFAULT(tcBaseClassLibFileName,tcAddOn )
      ENDIF
   RETURN lReturn AND NOT THIS.lError

   PROC SetDocTargets()
   
      LOCAL lReturn
   
      lReturn = THIS.SetDocTarget("THIS.cPrimaryDocTarget",;
                                  DOCSTRING_PICK_PRIMARY_TARGET)
                                  
      IF lReturn AND THIS.lSecondaryOutput
     
         lReturn = THIS.SetDocTarget("THIS.cSecondaryDocTarget", ;
                                      DOCSTRING_PICK_SECONDARY_TARGET)
      ENDIF

      IF lReturn
         lReturn = THIS.SetDocumentFolder()
      ENDIF
      IF lReturn 
         lReturn = THIS.VerifyDocTargets()
      ENDIF
    
   RETURN lReturn AND (NOT THIS.lError)
   
   PROC SetDocumentFolder
      LOCAL iPos   
      IF EMPTY(THIS.cDocumentFolder) OR ;
         (NOT DIRECTORY(THIS.cDocumentFolder))
         iPos = AT("\",THIS.cPrimaryDocTarget)      
         IF iPos = 0
            THIS.cDocumentFolder = SET("DIRECTORY")
         ELSE
            THIS.cDocumentFolder = SUBSTR(THIS.cPrimaryDocTarget,1,iPos)
         ENDIF
      ENDIF
      IF RIGHT(THIS.cDocumentFolder,1) # "\"
         THIS.cDocumentFolder = THIS.cDocumentFolder+"\"
      ENDIF
   RETURN (NOT THIS.lError)
   
   PROC VerifyDocTargets()
      IF AT("\",THIS.cPrimaryDocTarget) = 0
         THIS.cPrimaryDocTarget = THIS.cDocumentFolder+THIS.cPrimaryDocTarget
      ENDIF
      IF NOT EMPTY(SYS(2000,THIS.cPrimaryDocTarget))
         ERASE (THIS.cPrimaryDocTarget) RECYCLE
      ENDIF
      IF THIS.lSecondaryOutput
         IF AT("\",THIS.cSecondaryDocTarget) = 0
            THIS.cSecondaryDocTarget = THIS.cDocumentFolder+THIS.cSecondaryDocTarget
         ENDIF
         IF ALLTRIM(UPPER(THIS.cSecondaryDocTarget)) == ;
                          ALLTRIM(UPPER(THIS.cPrimaryDocTarget))
            THIS.cSecondaryDocTarget = THIS.GetTempFileName(THIS.cExt,THIS.cDocumentFolder,"CD")
                   
            MESSAGEBOX(DOCSTRING_FILENAMES_MUST_DIFFER, ;
                       DOC_WARNING_MESSAGEBOX )
         ENDIF
         IF NOT EMPTY(SYS(2000,THIS.cSecondaryDocTarget))
            ERASE (THIS.cSecondaryDocTarget) RECYCLE
         ENDIF
      ENDIF
   RETURN (NOT THIS.lError)

   PROC ProcessTargetFile
      LOCAL lReturn
      lReturn = THIS.CreateHeader() 
      IF lReturn
         lReturn = DODEFAULT()
      ENDIF
      IF lReturn
         lReturn = THIS.CreateFooter()
      ENDIF
   RETURN lReturn AND (NOT THIS.lError)
   
   PROC CreateHeader()
   RETURN NOT THIS.lError
   
   PROC CreateFooter()
   RETURN NOT THIS.lError
   
   PROC Destroy
      IF NOT THIS.lError
         IF THIS.lVisibleComponents
            IF THIS.lSecondaryOutput
               MESSAGEBOX(DOCSTRING_DOCUMENTS_CREATED, ;
                         DOC_INFO_MESSAGEBOX )
            ELSE
               MESSAGEBOX(DOCSTRING_DOC_CREATED, ;
                         DOC_INFO_MESSAGEBOX )
            ENDIF
         ELSE
            MODI COMM (THIS.cPrimaryDocTarget) NOWAIT
            IF THIS.lSecondaryOutput
               MODI COMM (THIS.cSecondaryDocTarget) NOWAIT
            ENDIF
         ENDIF
      ENDIF
   ENDPROC
   
   PROC GetTempFileName(tcExtensionToAdd, tcPathToAdd, tcPrefix)
      ASSERT _WINDOWS
      LOCAL cName, cExt, cPath, cPrefix
      IF TYPE("tcExtensionToAdd") = "C"
         cExt = IIF(LEFT(tcExtensionToAdd,1) = ".", ;
                    tcExtensionToAdd,"."+tcExtensionToAdd)
      ELSE
         cExt = ""
      ENDIF
      IF TYPE("tcPathToAdd") = "C"
         cPath = IIF(RIGHT(tcPathToAdd,1) = "\", ;
                           tcPathToAdd, tcPathToAdd+"\")
      ELSE
         cPath = ""
      ENDIF 
      IF TYPE("tcPrefix") = "C"
         cPrefix = tcPrefix
      ELSE
         cPrefix = ""
      ENDIF
      cName  = cPath+cPrefix+SYS(2015)+cExt
      DO WHILE NOT EMPTY(SYS(2000,cName))
         cName  = cPath+cPrefix+SYS(2015)+cExt
      ENDDO
   RETURN cName
   
  PROC SetDocTarget(tcWhichTarget,tcPrompt)
      LOCAL lReturn, lcPrompt, lcFile
      ASSERT TYPE(tcWhichTarget) = "C"
      IF TYPE("tcPrompt") # "C"
         lcPrompt = DOCSTRING_DEFAULT_GETFILE_PROMPT
      ELSE
         lcPrompt = tcPrompt
      ENDIF
      lcFile = ALLTR(EVAL(tcWhichTarget))
      IF EMPTY(lcFile)
         lcFile = ALLTR(THIS.GetLoc(lcPrompt, THIS.cExtPickString , ;
                                    DOC_PREFERENCE_PRIMARY_TARGET ,.F.))
         IF NOT EMPTY(lcFile)
            IF AT(".",lcFile) = 0
               lcFile = lcFile + "." + THIS.cExt
            ENDIF
         ENDIF
      ELSE
         IF AT(".",lcFile) = 0
            lcFile = lcFile + "." + THIS.cExt
         ENDIF
      ENDIF

      STORE lcFile TO (tcWhichTarget)      
      
      IF EMPTY(lcFile)
         MESSAGEBOX(tcWhichTarget+C_DOUBLE_CR+DOCSTRING_OUTPUT_FILE_NOT_SPECIFIED, ;
                    DOC_STOP_MESSAGEBOX )
      ELSE
         lReturn = .T.
      ENDIF

  RETURN lReturn AND NOT THIS.lError
  
ENDDEFINE

DEFINE CLASS ClassDoc AS Form

   * standard properties:
   DataSession = 2
   Name = "DocForm"
   Caption = DOCSTRING_DIALOG_CAPTION
   
   * defaults for preferences:
   cBaseClassLibFileName = LOWER(DOC_PREFERENCE_BASECLASS_VCX)
   cAddOn = DOC_PREFERENCE_ADDON 
   
   lNoCommonDialog = DOC_OMIT_TRYING_COMMON_DIALOG
   lOLEError = DOC_OMIT_TRYING_OCXS
   lOmitDirSearch = DOC_PREFERENCE_OMIT_DIRSEARCH
   
   * working properties:
   lVisibleComponents = .F.       
   lError = .F.
   cCurrentBaseClass = ""      
   cLibPath = ""
   cSourceAlias = "Source"
   cTargetAlias = "Target"

   DIME aClassLibFolders[1]

   PROC Load
      * datasession-specific settings only!
      SET MEMOWIDTH TO N_MEMOWIDTH
      SET DELETED ON
      SET EXACT OFF
      SET SAFETY OFF
      SET EXCLUSIVE OFF
      SET TALK OFF
   ENDPROC
      
   PROC Init(tcBaseClassLibFileName,tcAddOn )
   
      LOCAL lReturn
   
      lReturn = THIS.SetSourceClassLib(tcBaseClassLibFileName)      
      
      IF lReturn
         lReturn = THIS.AddClassesToTargetCursor()
      ENDIF
      
      IF lReturn
         lReturn = THIS.ProcessTargetFile()
      ENDIF
      
      IF lReturn
         lReturn = THIS.RunAddOn(tcAddOn)
      ENDIF      
      
      THIS.Cleanup()
  
   RETURN lReturn AND (NOT THIS.lError)
   

   PROC CreateClassOutput(tcThisClass,tiThisCount)
   RETURN NOT THIS.lError
  
   PROC Cleanup
      * non data-session-specific things I've messed with
      SET MESSAGE TO
      WAIT CLEAR
   RETURN NOT THIS.lError
   
   PROC ProcessTargetFile
                             
      SELECT (THIS.cSourceAlias)
  
      SCAN FOR (NOT EMPTY(TimeStamp)) AND (EMPTY(ClassLoc)) AND (EMPTY(Parent))
         * look only at the baseclass records:
         WAIT WINDOW NOWAIT DOCSTRING_PROCESSING_BASECLASSES
         THIS.cCurrentBaseClass = DOC_BASECLASS_IDENTIFIER
         IF NOT THIS.ProcessClassRecord(THIS.cCurrentBaseClass,1)
            EXIT
         ENDIF
         
      ENDSCAN

      WAIT CLEAR
      SET MESSAGE TO

   RETURN NOT THIS.lError
   
   PROC GetClassOutputLabel(tcThisClass)
      ASSERT TYPE("tcThisClass") = "C" AND NOT EMPTY(tcThisClass)
      LOCAL cClassLabel
      IF THIS.lOmitDirSearch
         cClassLabel = SUBSTR(tcThisClass,RAT("\",tcThisClass)+1)
      ELSE
         cClassLabel = tcThisClass
      ENDIF
   RETURN cClassLabel
      
   PROC ProcessClassRecord(tcThisClass, tiThisCount)
      LOCAL iRecNoTarget, cClassOutputLabel
      cClassOutputLabel = THIS.GetClassOutputLabel(tcThisClass)
      THIS.CreateClassOutput(cClassOutputLabel,tiThisCount)

      SELECT (THIS.cTargetAlias)
      
      SET MESSAGE TO DOCSTRING_SCANNING_FOR_CHILDREN+tcThisClass

      SCAN FOR DOC_PARENTCLASS_IDENTIFIER == tcThisClass 
          
         iRecnoTarget = RECNO()
         THIS.ProcessClassRecord(DOC_CLASS_IDENTIFIER,tiThisCount + 1)

         GO iRecnoTarget

         IF THIS.lError
            EXIT
         ENDIF

      ENDSCAN
       
   RETURN NOT THIS.lError
   
        
   PROC AddClassesToTargetCursor()
     * starting from one vcx indicated by the user
     * set up that vcx as the source, then
     * set up target table from all pertinent records
     * in all the vcxs in that folder
     WAIT WINDOW NOWAIT DOCSTRING_PREPARING_WORKFILES
     LOCAL ARRAY aStruct[1]
     LOCAL iIndex, iCols, iIndex2
          
     USE (THIS.cBaseClassLibFileName) ;
          ALIAS (THIS.cSourceAlias) AGAIN SHARED
          
     IF THIS.lError
         MESSAGEBOX(DOCSTRING_BASECLASSES_NOT_AVAILABLE, ;
                    DOC_STOP_MESSAGEBOX )
    
        RETURN .F.
     ENDIF
     
     COUNT FOR (NOT EMPTY(TimeStamp)) AND (EMPTY(ClassLoc)) AND (EMPTY(Parent))
     IF _TALLY = 0
        THIS.lError = .T.
        MESSAGEBOX( DOCSTRING_NO_BASECLASSES, ;
                    DOC_STOP_MESSAGEBOX )        
     ELSE
     
        * create the target with the same structure as VCX
        * with one more field, representing the VCX, 
        * in case of duplicate class names in multiple VCXs
        iIndex = AFIELDS(aStruct)   
        iIndex = iIndex + 1
        iCols = ALEN(aStruct,2)
     
        DIME aStruct[iIndex,iCols]
     
        aStruct[iIndex,1] = "ObjLoc"
        aStruct[iIndex,2] = "M" 
        aStruct[iIndex,3] = 4
        aStruct[iIndex,4] = 0
        aStruct[iIndex,5] = .F.
        aStruct[iIndex,6] = .F.
        FOR iIndex2 = 7 TO iCols
           aStruct[iIndex,iIndex2] = ""
        ENDFOR
     
        CREATE CURSOR (THIS.cTargetAlias) FROM ARRAY aStruct
        INDEX ON DOC_CLASS_IDENTIFIER TAG Identity
        INDEX ON DOC_PARENTCLASS_IDENTIFIER TAG PIdentity
        INDEX ON EMPTY(ObjLoc) TAG NewObjects
        SET ORDER TO 0
     
        * put in records for baseclasses and other
        * classes that may be descended from them,
        * first from all VCXs in this folder:
        THIS.AddClassesFromLibs(THIS.cLibPath)
     
        * and then from additional folders that 
        * the user may have specified:
        FOR iIndex = 1 TO ALEN(THIS.aClassLibFolders)
            IF NOT EMPTY(THIS.aClassLibFolders[iIndex])
               THIS.AddClassesFromLibs(THIS.aClassLibFolders[iIndex])
               IF THIS.lError
                  EXIT
               ENDIF
            ENDIF
        ENDFOR
     ENDIF
     
     IF NOT THIS.lError
        SELECT (THIS.cTargetAlias)     
        REPLACE ALL ObjName WITH LOWER(ALLTR(ObjName)),  ;
                    Class WITH LOWER(ALLTR(Class)), ;
                    ClassLoc WITH  ;
                             IIF(EMPTY(ClassLoc),ALLTR(ObjLoc), ;
                                 LOWER(FULLPATH( ALLTR(ClassLoc),ALLTR(ObjLoc) )) )
     ENDIF     
         
   RETURN NOT THIS.lError
   
   PROC AddClassesFromLibs(tcFolder)
   LOCAL iLibs, iIndex, cCursorName, cLibName
   LOCAL ARRAY aLibs[1]
       
     iLibs = ADIR(aLibs, tcFolder+"*.vcx")
     
     FOR iIndex = 1 TO iLibs
         * have to make sure to respect DELETED(),
         * so APPEND FROM is no good, and 
         * also want to make sure to get the VCX
         * info in...
         cCursorName = SYS(2015)
         cLibName = SYS(2015)
         USE (tcFolder+aLibs[iIndex,1]) AGAIN IN 0 ALIAS (cLibName) SHARED
         IF THIS.lError
             MESSAGEBOX(DOCSTRING_CLASSLIB_NOT_AVAILABLE, ;
                    DOC_WARNING_MESSAGEBOX )
    
            THIS.lError = .F.
         ELSE
            
            * because it will be opened by the 
            * SELECT and this way we can close it explicitly
            * in case there are two or more libraries in
            * different folders with the same name!
            SELECT * FROM (cLibName) ;
               INTO CURSOR (cCursorName) ;
               WHERE (NOT EMPTY(Timestamp)) AND (EMPTY(Parent))
                         
               * ignore the fontinfo/comment records,
               * respect DELETED() using SET DELETED and SELECT,
               * ignore members of containers, which can't be further subclassed
            
            IF _TALLY > 0
               
               SELECT (THIS.cTargetAlias)
               APPEND FROM (DBF(cCursorName))         
               LOCATE FOR EMPTY(ObjLoc)

               REPLACE REST ObjLoc WITH LOWER(tcFolder+aLibs[iIndex,1])
               USE IN (cCursorName)
               USE IN (cLibName)
         
            ENDIF

         ENDIF
         
     ENDFOR
     
   RETURN NOT THIS.lError
   
   PROC Error(nError, cMethod, nLine)
      THIS.lOLEError = ("/"+ALLTR(STR(nError))+"/" $ DOC_OLE_ERRORS)
      THIS.lError = .T.
      MESSAGEBOX( ;
         "Error # "+ALLTR(STR(nError))+C_DOUBLE_CR+ ;
          MESSAGE()+C_DOUBLE_CR+;
          cMethod+C_DOUBLE_CR+ ;
         "Line # "+ALLTR(STR(nLine)) +C_DOUBLE_CR+ ;
         MESSAGE(1) )
      IF DOC_DEBUG
         SUSPEND
      ENDIF
  ENDPROC

    
  PROC SetSourceClassLib(tcFile)

      LOCAL lReturn

      IF TYPE("tcFile") = "C"
         THIS.cBaseClassLibFileName = tcFile
      ENDIF
      
      THIS.cBaseClassLibFileName = ;
          LOWER(ALLTR(THIS.cBaseClassLibFileName))
      
      IF AT(".",THIS.cBaseClassLibFileName) = 0
         THIS.cBaseClassLibFileName = ;      
             THIS.cBaseClassLibFileName+".vcx"
      ENDIF
      
      IF EMPTY(THIS.cBaseClassLibFileName) OR ;
         NOT FILE(THIS.cBaseClassLibFileName)
     
         THIS.cBaseClassLibFileName =  ;
              THIS.GetLoc(DOCSTRING_GET_BASECLASSES, ;
                  "Visual Classlibs (*.vcx)|*.vcx|All files|*.*", ;
                   THIS.cBaseClassLibFileName ,.T.)
      ELSE

         IF AT(".",THIS.cBaseClassLibFileName) = 0
            THIS.cBaseClassLibFileName = ;
                THIS.cBaseClassLibFileName+".VCX"
         ENDIF

         THIS.cBaseClassLibFileName = ;
             FULLPATH(THIS.cBaseClassLibFileName)
                                
      ENDIF
      
      THIS.cBaseClassLibFileName = LOWER(THIS.cBaseClassLibFileName)

      DO CASE
      
      CASE EMPTY(THIS.cBaseClassLibFileName) 
         MESSAGEBOX(DOCSTRING_BASECLASSES_NOT_SPECIFIED, ;
                    DOC_STOP_MESSAGEBOX )

      CASE NOT FILE(THIS.cBaseClassLibFileName)
         MESSAGEBOX(DOCSTRING_BASECLASSES_NOT_FOUND, ;
                    DOC_STOP_MESSAGEBOX )

      OTHERWISE
         lReturn = .T.

      ENDCASE

      IF lReturn

         THIS.cLibPath = LOWER(LEFT(THIS.cBaseClassLibFileName, ;
                               RAT("\",THIS.cBaseClassLibFileName)))
         THIS.GetMoreClassLibFolders()
         
         THIS.Caption = THIS.Caption+":  "+UPPER(THIS.cBaseClassLibFileName)                                 
      ENDIF

  RETURN lReturn AND NOT THIS.lError

  PROC GetMoreClassLibFolders
  IF NOT THIS.lOmitDirSearch
     LOCAL iFolders, cFolderName
     iFolders = 0
     cFolderName = THIS.cLibPath
 
     DO WHILE NOT EMPTY(cFolderName)
        cFolderName = LOWER(GETDIR(cFolderName,DOCSTRING_OTHER_VCX_DIRS))
        IF NOT EMPTY(cFolderName)
           IF ASCAN(THIS.aClassLibFolders, cFolderName ) = 0 AND ;
              NOT (ALLTRIM(cFolderName) == ALLTRIM(LOWER(THIS.cLibPath)))
              iFolders = iFolders + 1
              DIME THIS.aClassLibFolders[iFolders]
              THIS.aClassLibFolders[iFolders] = cFolderName
           ENDIF
        ENDIF
     ENDDO
     IF ALEN(THIS.aClassLibFolders) = 1 AND ;
        EMPTY(THIS.aClassLibFolders[1])
        THIS.lOmitDirSearch = .T.
     ENDIF
  ENDIF
  RETURN  
  
  PROC GetLoc(tcTitle, tcFilter, tcFileName, tlFileMustExist)
     LOCAL cFileName

     IF (NOT THIS.lNoCommonDialog) AND ;
        (TYPE("THIS.cdlGetFileName") = "U" AND ;
         (NOT THIS.lOleError))
        * add common dialog if this is the first time:  
        THIS.AddObject("cdlGetFileName","cdlGetFile")
     ENDIF
     *&*&*&* for debugging GetFileFoxDialog
     *&*&*&* uncomment the following line:
     *&*&*&* THIS.lOleError = .T.
     *&*&*&*
     IF THIS.lOleError
        THIS.lError = .F.
        THIS.lOleError = .F.
        THIS.lNoCommonDialog = .T.
     ENDIF
     IF THIS.lNoCommonDialog 
        cFileName = THIS.GetFileFoxDialog(tcTitle, tcFilter, tcFileName, tlFileMustExist)
     ELSE
        cFileName = THIS.GetFileComDialog(tcTitle, tcFilter, tcFileName, tlFileMustExist)
     ENDIF
     * fix for common dialog problem with root dirs!
     cFileName = STRTRAN(cFileName,":.",":\")
     cFileName = STRTRAN(cFileName,"\\","\")
  RETURN cFileName

  PROC GetFileComDialog(tcTitle, tcFilter, tcFileName, tlFileMustExist)
     WITH THIS.cdlGetFileName
         
         IF TYPE("tcTitle") = "C"
            .DialogTitle = tcTitle
         ELSE
            .DialogTitle = ""
         ENDIF
         
         IF NOT EMPTY(tlFileMustExist)
            .Flags = cdlOFNFileMustExist + ;
                     cdlOFNPathMustExist + ; 
                     cdlOFNNoChangeDir   + ;
                     cdlOFNHideReadOnly
         ELSE
            .Flags = cdlOFNPathMustExist + ; 
                     cdlOFNNoChangeDir   + ;
                     cdlOFNHideReadOnly
         ENDIF
         
         IF TYPE("tcFileName") = "C"
            .FileName = tcFileName
         ELSE
            .FileName = ""
         ENDIF
         .Filter = tcFilter
         IF .lForceSearch
            .InitDir = ""
         ENDIF
     ENDWITH    

     THIS.cdlGetFileName.ShowOpen()

  RETURN LOWER(ALLTR(THIS.cdlGetFileName.FileName))

  PROC GetFileFoxDialog(tcTitle, tcFilter, tcFileName, tlFileMustExist)
     LOCAL cFileDefault, cTitle, nPosFilter, cFileToReturn
     
     IF TYPE("tcTitle") = "C"
        cTitle = tcTitle
     ELSE
        cTitle = ""
     ENDIF
     
     IF TYPE("tcFileName") = "C"
        cFileDefault = tcFileName
     ELSE
        cFileDefault = ""
     ENDIF
     
     IF NOT EMPTY(cFileDefault)
        cTitle = cTitle + DOCSTRING_GETFILE_DEFAULT+cFileDefault
     ENDIF

     WAIT WINDOW NOWAIT cTitle
     
     IF EMPTY(tcFilter)
        cFileToReturn = GETFILE()
     ELSE
        nPosFilter = AT(".",tcFilter)
        cFileToReturn = GETFILE(SUBSTR(tcFilter,nPosFilter+1,3))
     ENDIF
          
     IF tlFileMustExist AND ;
        (EMPTY(cFileToReturn) OR ;
         NOT FILE(cFileToReturn)) 

        cFileToReturn = cFileDefault      

     ENDIF    
     
     WAIT CLEAR

  RETURN LOWER(ALLTR(cFileToReturn))

  
  PROC RunAddOn(tcAddOn)
     LOCAL lReturn
     lReturn = .T.
     IF TYPE("tcAddOn") = "C" 
        THIS.cAddOn = UPPER(ALLTR(tcAddOn))
     ELSE
        THIS.cAddOn = UPPER(ALLTR(THIS.cAddOn))
     ENDIF
     IF NOT EMPTY(THIS.cAddOn)
        IF ( INLIST(RIGHT(THIS.cAddOn,4), ;
                    ".FXP",".APP",".PRG") AND ;
             FILE(THIS.cAddOn) ) OR ;
           ( AT(".",THIS.cAddOn) = 0 AND ;
            (FILE(THIS.cAddOn+".PRG") OR ;
             FILE(THIS.cAddOn+".FXP") OR ;
             FILE(THIS.cAddOn+".APP")) )   
          
           DO (THIS.cAddOn) WITH THIS
           * Add on must be a PRG, APP, or FXP,
           * although it may wrap around a form.
           * It must accept an object parameter,
           * reference to the docform object
           * It may adjust the size of the docform object
           * and add new controls to it. It may reset
           * the file that is going to be parsed according
           * to queries to the user of its own. It may choose
           * to adjust the doc form object's error flag
           * if it thinks the form shouldn't substantiate
           * based on its own errors, and provide its own
           * error messages stating the reason.
        ELSE
           MESSAGEBOX(DOCSTRING_ADDON_DOES_NOT_EXIST, ;
                      DOC_STOP_MESSAGEBOX )
           lReturn = .F.
        ENDIF
     ENDIF
        
  RETURN lReturn AND NOT THIS.lError
  
 
ENDDEFINE


DEFINE CLASS cdlGetFile AS OLEControl
   OLEClass = "MSComDlg.CommonDialog"
   lForceSearch = .T.
ENDDEFINE

DEFINE CLASS trvDoc AS OLEControl
   OLEClass = "COMCTL.TreeCtrl.1"
   
   PROC Init
      * doesn't work before this!!!
      * (can't put these properties
      *  in as initial values, above) 
      THIS.Style = 7
      THIS.LineStyle = 1
      THIS.LabelEdit = 1      
   ENDPROC
  
ENDDEFINE

